# This is a BitKeeper generated patch for the following project:
# Project Name: Linux 2.4 for PowerPC development tree
# This patch format is intended for GNU patch command version 2.5 or higher.
# This patch includes the following deltas:
#	arch/ppc/platforms/Makefile	1.17.1.2 -> 1.23   
#	  arch/ppc/config.in	1.127.1.5 -> 1.137  
#	arch/ppc/platforms/walnut.c	1.18.1.1 -> 1.23   
#	arch/ppc/kernel/setup.c	1.102   -> 1.103  
#	arch/ppc/kernel/ocp.c	1.5.1.1 -> 1.7    
#	arch/ppc/platforms/walnut.h	1.26    -> 1.29   
#	arch/ppc/kernel/ppc405_pci.c	1.9     -> 1.13   
#	arch/ppc/kernel/ppc4xx_setup.c	1.41    -> 1.43   
#	arch/ppc/boot/utils/mkimage.wrapper	1.1     -> 1.2    
#	arch/ppc/kernel/Makefile	1.91.1.4 -> 1.96   
#	               (new)	        -> 1.5     arch/ppc/platforms/snic.c
#	               (new)	        -> 1.2     arch/ppc/platforms/multi405.h
#	               (new)	        -> 1.2     arch/ppc/platforms/snic.h
#	               (new)	        -> 1.7     arch/ppc/platforms/multi405.c
diff -Nru a/arch/ppc/boot/utils/mkimage.wrapper b/arch/ppc/boot/utils/mkimage.wrapper
--- a/arch/ppc/boot/utils/mkimage.wrapper	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/boot/utils/mkimage.wrapper	Mon Apr 29 17:59:03 2002
@@ -4,7 +4,7 @@
 # Build PPCBoot image when `mkimage' tool is available.
 #
 
-MKIMAGE=$(type -path mkimage)
+MKIMAGE=/usr/local/pkgs/mkimage
 
 if [ -z "${MKIMAGE}" ]; then
 	# Doesn't exist
diff -Nru a/arch/ppc/config.in b/arch/ppc/config.in
--- a/arch/ppc/config.in	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/config.in	Mon Apr 29 17:59:03 2002
@@ -72,7 +72,8 @@
 
 if [ "$CONFIG_40x" = "y" ]; then
     choice 'Machine Type'			\
-	"Ash		CONFIG_ASH		\
+        "Multiple       CONFIG_MULTI_405        \
+	 Ash		CONFIG_ASH		\
 	 Ceder		CONFIG_CEDER		\
 	 CPCI405	CONFIG_CPCI405 		\
 	 EP405/EP405PC	CONFIG_EP405 		\
@@ -81,8 +82,19 @@
 	 Redwood-4	CONFIG_REDWOOD_4 	\
 	 Redwood-5	CONFIG_REDWOOD_5 	\
 	 Tivo		CONFIG_TIVO 		\
+	 Snic           CONFIG_SNIC		\
 	 Walnut		CONFIG_WALNUT"	Walnut
 
+    if [ "$CONFIG_WALNUT" = "y" ]; then
+      choice 'Walnut BIOS'                     \
+             "OpenBIOS      CONFIG_WALNUT_OB   \
+              PPCBoot       CONFIG_WALNUT_PPCBOOT" OpenBIOS
+    fi
+    dep_bool 'ViaSat SNIC'   CONFIG_MULTI_SNIC    $CONFIG_MULTI_405
+    dep_bool 'Walnut'        CONFIG_MULTI_WALNUT  $CONFIG_MULTI_405
+
+    dep_bool 'Walnut OpenBIOS' CONFIG_WALNUT_OB $CONFIG_MULTI_WALNUT
+   
    if [ "$CONFIG_EP405" = "y" ]; then
       bool 'EP405PC Support' CONFIG_EP405PC
    fi  
@@ -295,7 +307,18 @@
     define_bool CONFIG_IBM405_ERR77 y
     define_bool CONFIG_IBM_OCP y
   fi
-
+  if [ "$CONFIG_SNIC" = "y" ]; then
+    define_bool CONFIG_405GP y
+    define_bool CONFIG_IBM405_ERR77 y
+    define_bool CONFIG_IBM_OCP y
+  fi
+  if [ "$CONFIG_MULTI_405" = "y" ]; then
+    define_bool CONFIG_TREEBOOT y
+    define_bool CONFIG_405GP y
+    define_bool CONFIG_BIOS_FIXUP y
+    define_bool CONFIG_IBM405_ERR77 y
+    define_bool CONFIG_IBM_OCP y
+  fi    
   bool 'Blue Logic DMA' CONFIG_405_DMA
   if [ "$CONFIG_405GP" = "y" -o \
        "$CONFIG_NP405L" = "y" -o \
@@ -321,7 +344,7 @@
 fi
 
 if [ "$CONFIG_4xx" = "y" ]; then
-  dep_bool 'OCP Device proc fs support (experimental)' CONFIG_OCP_PROC
+  dep_bool 'OCP Device proc fs support (experimental)' CONFIG_OCP_PROC $CONFIG_EXPERIMENTAL
 fi
 
 if [ "$CONFIG_8xx" = "y" -o "$CONFIG_8260" = "y" ]; then
diff -Nru a/arch/ppc/kernel/ppc405_pci.c b/arch/ppc/kernel/ppc405_pci.c
--- a/arch/ppc/kernel/ppc405_pci.c	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/kernel/ppc405_pci.c	Mon Apr 29 17:59:03 2002
@@ -198,10 +198,13 @@
 	hose_a->last_busno = pciauto_bus_scan(hose_a, hose_a->first_busno);
 	hose_a->last_busno = 0;
 
-	/* Setup ppc_md */
+        /*move these into board specfic files*/
 	ppc_md.pcibios_fixup     	= NULL;
 	ppc_md.pci_exclude_device	= ppc4xx_exclude_device;
 	ppc_md.pcibios_fixup_resources	= ppc405_pcibios_fixup_resources;
+#if 0
+	/* Setup ppc_md */
 	ppc_md.pci_swizzle		= common_swizzle;
 	ppc_md.pci_map_irq		= ppc405_map_irq;
+#endif
 }
diff -Nru a/arch/ppc/kernel/ppc4xx_setup.c b/arch/ppc/kernel/ppc4xx_setup.c
--- a/arch/ppc/kernel/ppc4xx_setup.c	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/kernel/ppc4xx_setup.c	Mon Apr 29 17:59:03 2002
@@ -43,6 +43,7 @@
 #include <linux/rtc.h>
 #include <linux/console.h>
 #include <linux/ide.h>
+#include <linux/serial.h>
 #include <linux/serial_reg.h>
 #include <linux/seq_file.h>
 
@@ -60,6 +61,7 @@
 
 /* Function Prototypes */
 static void ppc4xx_gdb_init(void);
+static void ppc4xx_early_serial_init(void);
 
 extern void abort(void);
 extern void ppc4xx_find_bridges(void);
@@ -82,15 +84,17 @@
 extern unsigned long wdt_period;
 
 /* Board specific functions */
-extern void board_setup_arch(void);
-extern void board_io_mapping(void);
-extern void board_setup_irq(void);
+/*
+  extern void board_setup_arch(void);
+  extern void board_io_mapping(void);
+  extern void board_setup_irq(void);
+*/
 extern void board_init(void);
 
 /* Global Variables */
 unsigned char __res[sizeof (bd_t)];
 
-static void __init
+void __init
 ppc4xx_setup_arch(void)
 {
 
@@ -104,9 +108,74 @@
 	conswitchp = &dummy_con;
 #endif
 
-	board_setup_arch();
-
 	ppc4xx_gdb_init();
+
+        ppc4xx_early_serial_init();
+}
+
+/*
+ * This function will call early_serial_setup to
+ * set the base baud rate dymanically if we are using
+ * an internal clock. If the board has an external clock
+ * it will have to have BASE_BAUD set correctly.
+ *
+ * This function is not __init so it can be called if serial
+ * support is modular.
+ * 
+ */
+static void
+ppc4xx_early_serial_init(void)
+{
+        struct serial_struct serial_req;
+	bd_t *bip = (bd_t *) __res;
+        u32 chrcr;
+        int div;
+
+        chrcr = mfdcr(DCRN_CHCR0);
+
+	if ( ( chrcr & CHR0_U0EC ) || ( chrcr & CHR0_U1EC ) ) {
+		chrcr &= ~( CHR0_U0EC | CHR0_U1EC );
+		chrcr &= ~( CHR0_UDIV );
+		chrcr |= ( 15 << 1 ) & CHR0_UDIV;
+
+		mtdcr( DCRN_CHCR0, chrcr );
+	}
+
+        div = ( ( chrcr & CHR0_UDIV ) >> 1 ) + 1;
+        div *= 16;
+
+        if( div && !(chrcr & CHR0_U0EC) ){
+                memset(&serial_req, 0, sizeof(serial_req));
+                serial_req.line       = 0;
+                serial_req.baud_base  = bip->bi_intfreq/div;;
+                serial_req.port       = 0;
+                serial_req.irq        = UART0_INT;
+                serial_req.flags      = ASYNC_BOOT_AUTOCONF | ASYNC_SKIP_TEST;
+                serial_req.io_type    = SERIAL_IO_MEM;
+                serial_req.iomem_base = (u8 *)UART0_IO_BASE;
+                serial_req.iomem_reg_shift = 0;
+                
+                
+                if (early_serial_setup(&serial_req) != 0) {
+                        /*printk("Early serial init of port 0 failed\n");*/
+                }
+        }
+        if( div && !(chrcr & CHR0_U1EC) ){
+                memset(&serial_req, 0, sizeof(serial_req));
+                serial_req.line       = 1;
+                serial_req.baud_base  = bip->bi_intfreq/div;;
+                serial_req.port       = 1;
+                serial_req.irq        = UART1_INT;
+                serial_req.flags      = ASYNC_BOOT_AUTOCONF | ASYNC_SKIP_TEST;
+                serial_req.io_type    = SERIAL_IO_MEM;
+                serial_req.iomem_base = (u8 *)UART1_IO_BASE;
+                serial_req.iomem_reg_shift = 0;
+                
+                
+                if (early_serial_setup(&serial_req) != 0) {
+                        /*printk("Early serial init of port 1 failed\n");*/
+                }
+        }
 }
 
 /*
@@ -155,7 +224,7 @@
 	return ((unsigned long) bip->bi_memsize);
 }
 
-static void __init
+void __init
 m4xx_map_io(void)
 {
 	io_block_mapping(PPC4xx_ONB_IO_VADDR,
@@ -168,10 +237,9 @@
 	io_block_mapping(PPC4xx_PCI_LCFG_VADDR,
 			 PPC4xx_PCI_LCFG_PADDR, PPC4xx_PCI_LCFG_SIZE, _PAGE_IO);
 #endif
-	board_io_mapping();
 }
 
-static void __init
+void __init
 ppc4xx_init_IRQ(void)
 {
 	int i;
@@ -181,8 +249,6 @@
 	for (i = 0; i < NR_IRQS; i++)
 		irq_desc[i].handler = ppc4xx_pic;
 
-	/* give board specific code a chance to setup things */
-	board_setup_irq();
 	return;
 }
 
diff -Nru a/arch/ppc/kernel/setup.c b/arch/ppc/kernel/setup.c
--- a/arch/ppc/kernel/setup.c	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/kernel/setup.c	Mon Apr 29 17:59:03 2002
@@ -596,7 +596,7 @@
 			= cur_cpu_spec[0]->dcache_bsize;
 
 	/* reboot on panic */
-	panic_timeout = 180;
+	panic_timeout = 1;
 
 	init_mm.start_code = PAGE_OFFSET;
 	init_mm.end_code = (unsigned long) _etext;
diff -Nru a/arch/ppc/platforms/Makefile b/arch/ppc/platforms/Makefile
--- a/arch/ppc/platforms/Makefile	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/platforms/Makefile	Mon Apr 29 17:59:03 2002
@@ -31,9 +31,14 @@
 obj-$(CONFIG_REDWOOD_4)		+= redwood.o ibmstb3.o
 obj-$(CONFIG_REDWOOD_5)		+= redwood5.o ibmstb4.o
 obj-$(CONFIG_WALNUT)		+= walnut.o ibm405gp.o
+obj-$(CONFIG_SNIC)              += snic.o ibm405gp.o
 obj-$(CONFIG_ASH)		+= ash.o ibmnp405h.o
 obj-$(CONFIG_RAINIER)		+= rainier.o ibmnp4gs.o
 obj-$(CONFIG_APUS)		+= apus_setup.o
+
+obj-$(CONFIG_MULTI_405)         += multi405.o ibm405gp.o
+obj-$(CONFIG_MULTI_SNIC)        += snic.o
+obj-$(CONFIG_MULTI_WALNUT)      += walnut.o
 
 obj-$(CONFIG_EBONY)		+= ebony.o ibm440gp.o
 
diff -Nru a/arch/ppc/platforms/multi405.c b/arch/ppc/platforms/multi405.c
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/arch/ppc/platforms/multi405.c	Mon Apr 29 17:59:03 2002
@@ -0,0 +1,96 @@
+/*
+ *
+ *    Copyrigh t(c) 2002 Andrew May <amay@viasat.com>
+ *
+ *    Module name: multi405.c
+ *
+ *    Description:
+ *      Simple hack to wrap the board specfic functions and switch
+ *      them out to the correct board calls.
+ *
+ */
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/serial.h>
+#include <linux/string.h>
+
+#include <asm/system.h>
+#include <asm/pci-bridge.h>
+
+#include <platforms/multi405.h>
+#include <platforms/ibm_ocp.h>
+
+extern int snic_probe(void);
+
+char* ppc4xx_machine_name;
+struct board_calls multi405_bd;
+
+__u32 pbxcr_405GP( int n )
+{
+#define EBCCFGADR  0x012
+#define EBCCFGDATA 0x013
+	__u32 pbcr = 0;
+
+	if ( n >= 0 && n <= 7 ) {
+		mtdcr( EBCCFGADR, n );
+		pbcr = mfdcr( EBCCFGDATA );
+	}
+
+	return pbcr;
+}
+
+void __init
+bios_fixup(struct pci_controller *hose, struct pcil0_regs *pcip)
+{
+        printk("multi405 bios fixup calling %p\n", multi405_bd.bios_fixup );
+        if( multi405_bd.bios_fixup )
+                (*multi405_bd.bios_fixup)(hose, pcip);
+}
+
+static char board_name[] = "Unkown 405";
+
+void __init
+board_init(void)
+{
+        int found = 0;
+#ifdef CONFIG_WALNUT_OB
+	bd_t *bip = (bd_t *) __res;
+
+        struct open_bios_info* ob = (struct open_bios_info*)__res;
+
+        /*dirty hack to check for OpenBios then copy to ppcboot like struct*/
+        if( strncmp( bip->bi_r_version, "PPCBoot", 7 ) ) {
+                struct bd_info bd;
+                memset( &bd, 0, sizeof(bd_t) );
+
+                bd.bi_memsize   = ob->bi_memsize;
+
+                memcpy( (void*) bd.bi_enetaddr, (void*)ob->bi_enetaddr, 
+                        6 );
+                memcpy( (void*) bd.bi_pci_enetaddr, (void*)ob->bi_pci_enetaddr, 
+                        6 );
+                bd.bi_intfreq = ob->bi_intfreq;
+                bd.bi_busfreq = ob->bi_busfreq;
+                bd.bi_pci_busfreq = ob->bi_pci_busfreq;
+                
+                memcpy( (void*)__res, &bd, sizeof(bd_t) );
+        }
+#endif
+        /* Could set defaults here or if only one board skip probe*/
+        multi405_bd.bios_fixup   = 0;
+
+        ppc4xx_machine_name      = board_name;
+
+#ifdef CONFIG_MULTI_WALNUT
+        if( !found )
+                found = walnut_setup();
+#endif
+
+#ifdef CONFIG_SNIC2
+        if( !found )
+                found = snic_probe();
+#endif
+        /*we problably could just continue*/
+        if( !found )
+                printk( KERN_ERR "Could not find valid 405Type board\n" );
+}
diff -Nru a/arch/ppc/platforms/multi405.h b/arch/ppc/platforms/multi405.h
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/arch/ppc/platforms/multi405.h	Mon Apr 29 17:59:03 2002
@@ -0,0 +1,85 @@
+/*
+ * 405 common board definitions
+ *
+ * Copyright (c) 2002 Andrew May (amay@viasat.com)
+ */
+
+#ifndef __ASM_MULTI405_H_
+#define __ASM_MULTI405_H_
+
+#include <linux/config.h>
+
+/* We have a 405GP core */
+#include <platforms/ibm405gp.h>
+
+#include <asm/ppcboot.h>
+
+#ifndef __ASSEMBLY__
+
+#define PBXCR_BAS( n ) ( ( n >> 21 ) & 0x0FFF )
+#define PBXCR_BW( n )  ( ( n >> 13 ) & 0x03 )
+
+__u32 pbxcr_405GP( int );
+
+#if 1
+/*
+ * Data structure defining board information maintained by the boot
+ * ROM on IBM's "Walnut" evaluation board. An effort has been made to
+ * keep the field names consistent with the 8xx 'bd_t' board info
+ * structures.
+ * For this board the values get copied into a PPCBoot bd_t struct
+ * along with some other stuff.
+ */
+struct open_bios_info {
+	unsigned char	 bi_s_version[4];	/* Version of this structure */
+	unsigned char	 bi_r_version[30];	/* Version of the IBM ROM */
+	unsigned int	 bi_memsize;		/* DRAM installed, in bytes */
+	unsigned char	 bi_enetaddr[6];	/* Local Ethernet MAC address */
+	unsigned char	 bi_pci_enetaddr[6];	/* PCI Ethernet MAC address */
+	unsigned int	 bi_intfreq;		/* Processor speed, in Hz */
+	unsigned int	 bi_busfreq;		/* PLB Bus speed, in Hz */
+	unsigned int	 bi_pci_busfreq;	/* PCI Bus speed, in Hz */
+};
+#endif
+
+/* Some 4xx parts use a different timebase frequency from the internal clock.
+*/
+#define bi_tbfreq bi_intfreq
+
+/* Unlike machdep_calls these are __init functions that are called once
+ * tossed.  
+ */
+struct pci_controller;
+struct pcil0_regs;
+struct board_calls{
+        void (*bios_fixup)(struct pci_controller *hose, struct pcil0_regs *pcip);
+        void (*setup_arch)(void);
+        void (*io_mapping)(void);
+        void (*setup_irq)(void);
+};
+extern char * ppc4xx_machine_name;
+extern struct board_calls multi405_bd;
+#define PPC4xx_MACHINE_NAME ppc4xx_machine_name
+
+#endif /*ASM*/
+
+/* Early initialization address mapping for block_io.
+ * Standard 405GP map.
+ */
+#define PPC4xx_PCI_IO_PADDR	((uint)PPC405_PCI_PHY_IO_BASE)
+#define PPC4xx_PCI_IO_VADDR	PPC4xx_PCI_IO_PADDR
+#define PPC4xx_PCI_IO_SIZE	((uint)64*1024)
+#define PPC4xx_PCI_CFG_PADDR	((uint)PPC405_PCI_CONFIG_ADDR)
+#define PPC4xx_PCI_CFG_VADDR	PPC4xx_PCI_CFG_PADDR
+#define PPC4xx_PCI_CFG_SIZE	((uint)4*1024)
+#define PPC4xx_PCI_LCFG_PADDR	((uint)0xef400000)
+#define PPC4xx_PCI_LCFG_VADDR	PPC4xx_PCI_LCFG_PADDR
+#define PPC4xx_PCI_LCFG_SIZE	((uint)4*1024)
+#define PPC4xx_ONB_IO_PADDR	((uint)0xef600000)
+#define PPC4xx_ONB_IO_VADDR	PPC4xx_ONB_IO_PADDR
+#define PPC4xx_ONB_IO_SIZE	((uint)4*1024)
+
+/*This is the external clock rate suggested in the manual*/
+#define BASE_BAUD	        18432000
+
+#endif /*__ASM_MULTI405_H_*/
diff -Nru a/arch/ppc/platforms/snic.c b/arch/ppc/platforms/snic.c
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/arch/ppc/platforms/snic.c	Mon Apr 29 17:59:03 2002
@@ -0,0 +1,167 @@
+/*
+ * Board setup routines for the Viasat SNIC
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/pci.h>
+#include <asm/system.h>
+#include <asm/pci-bridge.h>
+#include <asm/machdep.h>
+#include <asm/todc.h>
+#include <linux/serial.h>
+
+#include <platforms/multi405.h>
+#include <platforms/snic.h>
+
+#if 0
+#define DEBUG 1
+#endif
+
+extern void ppc4xx_setup_arch(void);
+extern void m4xx_map_io(void);
+
+int __init
+snic_map_irq(struct pci_dev *dev, unsigned char idsel, unsigned char pin)
+{
+	static char pci_irq_table[][4] =
+	/*
+	 *      PCI IDSEL/INTPIN->INTLINE
+	 *      A       B       C       D
+	 */
+	{
+		{4,	4,	4,	4},	/* IDSEL 0 */
+		{25,	25,	25,	25},	/* IDSEL 1 */
+		{25,	25,	25,	25},	/* IDSEL 2 */
+		{25,	25,	25,	25},	/* IDSEL 3 */
+		{25,	25,	25,	25},	/* IDSEL 4 */
+		{25,	25,	25,	25},	/* IDSEL 5 */
+		{31,	30,	29,	28},	/* IDSEL 6 */
+		{25,	25,	25,	25},	/* IDSEL 7 */
+		{25,	25,	25,	25},	/* IDSEL 8 */
+		{25,	25,	25,	25},	/* IDSEL 9 */
+        };
+	const long min_idsel = 0, max_idsel = 9, irqs_per_slot = 4;
+	return PCI_IRQ_TABLE_LOOKUP;
+};
+
+void __init
+snic_setup_arch(void)
+{
+        gpio_t * gpio = (gpio_t *)GPIO0_BASE;
+#if 1
+        unsigned short*snic_cpld;
+        
+        ppc4xx_setup_arch();
+
+#define SNIC_CPLD_BASE       0xF0000000
+        snic_cpld = ioremap(SNIC_CPLD_BASE, 0x7<<1 );
+        if(!snic_cpld){
+                printk(KERN_CRIT "snic_setup_arch() failed to ioremap CPLD\n" );                
+        }
+        printk(KERN_INFO "cpld vals "
+               "0x%04x 0x%04x 0x%04x 0x%04x " 
+               "0x%04x 0x%04x 0x%04x 0x%04x" 
+               "\n", 
+               readw(&snic_cpld[0]),
+               readw(&snic_cpld[1]),
+               readw(&snic_cpld[2]),
+               readw(&snic_cpld[3]),
+               readw(&snic_cpld[4]),
+               readw(&snic_cpld[5]),
+               readw(&snic_cpld[6]),
+               readw(&snic_cpld[7]) );
+        writew(0, &snic_cpld[1]);
+        /*iounmap(snic_cpld);*/
+#endif
+        /* 
+           We already should be out of High-z from ppcboot but
+           do it again anyways then turn on the oposite bits
+        */
+        gpio->tcr = 0x7fc00000;
+        gpio->or  = 0xaa800000;
+
+}
+
+void __init
+snic_io_mapping(void)
+{
+        m4xx_map_io();/*do the default 4xx mapping*/
+
+        io_block_mapping( PPC405_PCI_LOWER_MEM,
+                          PPC405_PCI_LOWER_MEM, (PPC405_PCI_UPPER_MEM-PPC405_PCI_LOWER_MEM+1), _PAGE_IO );
+}
+
+void __init
+snic_bios_fixup(struct pci_controller *hose, struct pcil0_regs *pcip)
+{
+	unsigned int bar_response, bar;
+
+#ifdef DEBUG
+	int i;
+
+	printk("ioremap PCLIO_BASE = 0x%p\n", pcip);
+	printk("PCI bridge regs before fixup \n");
+	for (i = 0; i < 3; i++) {
+		printk(" pmm%d\tma 0x%08x\tla 0x%08x\tpcila 0x%08x\tpciha 0x%08x\n", i, 
+                       in_le32(&(pcip->pmm[i].ma)),
+                       in_le32(&(pcip->pmm[i].la)),
+                       in_le32(&(pcip->pmm[i].pcila)),
+                       in_le32(&(pcip->pmm[i].pciha)) );
+	}
+	printk(" ptm1\tms 0x%08x\tla 0x%08x\n", in_le32(&(pcip->ptm1ms)), in_le32(&(pcip->ptm1la)) );
+	printk(" ptm2\tms 0x%08x\tla 0x%08x\n", in_le32(&(pcip->ptm2ms)), in_le32(&(pcip->ptm2la)) );
+
+	/* Read config bars */
+	for (bar = PCI_BASE_ADDRESS_1; bar <= PCI_BASE_ADDRESS_2; bar += 4) {
+		early_read_config_dword(hose, hose->first_busno,
+					PCI_FUNC(hose->first_busno), bar,
+					&bar_response);
+		printk("BUS %d, device %d, Function %d bar 0x%8.8x is 0x%8.8x\n",
+		    hose->first_busno, PCI_SLOT(hose->first_busno),
+		    PCI_FUNC(hose->first_busno), bar, bar_response);
+	}
+	/* end work arround */
+#endif
+}
+
+/*don't want this marked __init*/
+static char boad_name[] = "Viasat SNIC";
+
+int snic_probe(void)
+{
+	bd_t *bip = (bd_t *) __res;
+
+        if( bip->bi_flashsize != 0x01000000 ){
+                return 0;
+        }
+        ppc4xx_machine_name      = boad_name;
+
+        ppc_md.setup_arch        = snic_setup_arch;
+        /*ppc_md.init_IRQ          = ppc4xx_init_IRQ;*/
+
+        ppc_md.setup_io_mappings = snic_io_mapping;
+
+#ifdef CONFIG_PCI
+        ppc_md.pci_swizzle		= common_swizzle;
+        ppc_md.pci_map_irq		= snic_map_irq;
+#endif
+
+#ifdef CONFIG_PPC_RTC
+	ppc_md.time_init = todc_time_init;
+	ppc_md.set_rtc_time = todc_set_rtc_time;
+	ppc_md.get_rtc_time = todc_get_rtc_time;
+	ppc_md.nvram_read_val = todc_direct_read_val;
+	ppc_md.nvram_write_val = todc_direct_write_val;
+#endif
+        return 1;
+}
+
+#ifndef CONFIG_MULTI_405
+void __init
+board_init(void)
+{
+        snic_probe();
+}
+#endif
diff -Nru a/arch/ppc/platforms/snic.h b/arch/ppc/platforms/snic.h
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/arch/ppc/platforms/snic.h	Mon Apr 29 17:59:03 2002
@@ -0,0 +1,13 @@
+/*
+ * ViaSat SNIC board specific definitions
+ *
+ * Copyright (c) 2002 Andrew May (amay@viasat.com)
+ */
+
+#ifndef __ASM_SNIC2_H__
+#define __ASM_SNIC2_H__
+
+/* We have a 405GP core */
+#include <platforms/multi405.h>
+
+#endif	/* __ASM_SNIC2_H__ */
diff -Nru a/arch/ppc/platforms/walnut.c b/arch/ppc/platforms/walnut.c
--- a/arch/ppc/platforms/walnut.c	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/platforms/walnut.c	Mon Apr 29 17:59:03 2002
@@ -31,6 +31,7 @@
 #include <linux/blk.h>
 #include <linux/pci.h>
 #include <linux/rtc.h>
+#include <linux/serial.h>
 
 #include <asm/system.h>
 #include <asm/pci-bridge.h>
@@ -53,10 +54,15 @@
 #define DBG(x...)
 #endif
 
+#include <platforms/walnut.h>
+
 void *kb_cs;
 void *kb_data;
 void *walnut_rtc_base;
 
+extern void ppc4xx_setup_arch(void);
+extern void m4xx_map_io(void);
+
 extern void early_uart_init(void);
 extern void ocp_uart_init(void);
 
@@ -64,7 +70,7 @@
  * Used by the generic 405 PCI setup functions in ppc4xx_pci.c
  */
 int __init
-ppc405_map_irq(struct pci_dev *dev, unsigned char idsel, unsigned char pin)
+walnut_map_irq(struct pci_dev *dev, unsigned char idsel, unsigned char pin)
 {
 	static char pci_irq_table[][4] =
 	    /*
@@ -83,7 +89,7 @@
 };
 
 void __init
-board_setup_arch(void)
+walnut_setup_arch(void)
 {
 #define WALNUT_PS2_BASE		0xF0100000
 #define WALNUT_FPGA_BASE	0xF0300000
@@ -95,7 +101,10 @@
 	void *fpga_status;
 	void *fpga_trigger;
 
+	ppc4xx_setup_arch();
+
 	early_uart_init();
+
 	kb_data = ioremap(WALNUT_PS2_BASE, 8);
 	if (!kb_data) {
 		printk(KERN_CRIT
@@ -138,6 +147,7 @@
 	printk("IBM Walnut port (C) 2000-2002 MontaVista Software, Inc. (source@mvista.com)\n");
 }
 
+#ifndef CONFIG_MULTI_405
 void __init
 bios_fixup(struct pci_controller *hose, struct pcil0_regs *pcip)
 {
@@ -237,27 +247,61 @@
 
 #endif
 }
+#endif
 
+#ifdef CONFIG_PPC_RTC
+/*
+ * This function is only needed if RTC is used.
+ */
 void __init
-board_io_mapping(void)
+walnut_io_mapping(void)
 {
+	m4xx_map_io();
 	io_block_mapping(WALNUT_RTC_VADDR,
 			 WALNUT_RTC_PADDR, WALNUT_RTC_SIZE, _PAGE_IO);
 }
+#endif
 
-void __init
-board_setup_irq(void)
+/*
+ * The actual work done in board_init, either called from below
+ * or in multi405.c
+ */
+int __init
+walnut_setup(void)
 {
-}
+#ifdef CONFIG_MULTI_405
+	if ( !( PBXCR_BAS( pbxcr_405GP( 2 ) ) == PBXCR_BAS( WALNUT_PS2_BASE ) ) ||
+	     !( PBXCR_BAS( pbxcr_405GP( 7 ) ) == PBXCR_BAS( WALNUT_FPGA_BASE ) ) ) {
+		return 0;
+	}
+#endif
+
+        ppc_md.setup_arch        = walnut_setup_arch;
+        /*Leave at default set in platform_init
+          ppc_md.init_IRQ          = ppc4xx_init_IRQ;
+        */
+
+#ifdef CONFIG_PCI
+        ppc_md.pci_swizzle		= common_swizzle;
+        ppc_md.pci_map_irq		= walnut_map_irq;
+#endif
 
-void __init
-board_init(void)
-{
 #ifdef CONFIG_PPC_RTC
+        ppc_md.setup_io_mappings = walnut_io_mapping;
 	ppc_md.time_init = todc_time_init;
 	ppc_md.set_rtc_time = todc_set_rtc_time;
 	ppc_md.get_rtc_time = todc_get_rtc_time;
 	ppc_md.nvram_read_val = todc_direct_read_val;
 	ppc_md.nvram_write_val = todc_direct_write_val;
 #endif
+
+	return 1;
 }
+
+#ifndef CONFIG_MULTI_405
+void __init
+board_init(void)
+{
+        walnut_setup();
+}
+#endif
diff -Nru a/arch/ppc/platforms/walnut.h b/arch/ppc/platforms/walnut.h
--- a/arch/ppc/platforms/walnut.h	Mon Apr 29 17:59:03 2002
+++ b/arch/ppc/platforms/walnut.h	Mon Apr 29 17:59:03 2002
@@ -27,29 +27,46 @@
 /* We have a 405GP core */
 #include <platforms/ibm405gp.h>
 
+
 #ifndef __ASSEMBLY__
+
+/* Some 4xx parts use a different timebase frequency from the internal clock.
+*/
+#define bi_tbfreq bi_intfreq
+
+#ifdef CONFIG_MULTI_405
+#include <platforms/multi405.h>
+#else
+#ifdef CONFIG_WALNUT_PPCBOOT
+#include <asm/ppcboot.h>
+#else /*CONFIG_WALNUT_OB*/
 /*
  * Data structure defining board information maintained by the boot
  * ROM on IBM's "Walnut" evaluation board. An effort has been made to
  * keep the field names consistent with the 8xx 'bd_t' board info
  * structures.
  */
-
 typedef struct board_info {
-	unsigned char	 bi_s_version[4];	/* Version of this structure */
-	unsigned char	 bi_r_version[30];	/* Version of the IBM ROM */
-	unsigned int	 bi_memsize;		/* DRAM installed, in bytes */
-	unsigned char	 bi_enetaddr[6];	/* Local Ethernet MAC address */
-	unsigned char	 bi_pci_enetaddr[6];	/* PCI Ethernet MAC address */
-	unsigned int	 bi_intfreq;		/* Processor speed, in Hz */
-	unsigned int	 bi_busfreq;		/* PLB Bus speed, in Hz */
-	unsigned int	 bi_pci_busfreq;	/* PCI Bus speed, in Hz */
+       unsigned char    bi_s_version[4];       /* Version of this structure */
+       unsigned char    bi_r_version[30];      /* Version of the IBM ROM */
+       unsigned int     bi_memsize;            /* DRAM installed, in bytes */
+       unsigned char    bi_enetaddr[6];        /* Local Ethernet MAC address */
+       unsigned char    bi_pci_enetaddr[6];    /* PCI Ethernet MAC address */
+       unsigned int     bi_intfreq;            /* Processor speed, in Hz */
+       unsigned int     bi_busfreq;            /* PLB Bus speed, in Hz */
+       unsigned int     bi_pci_busfreq;        /* PCI Bus speed, in Hz */
 } bd_t;
+#endif/*CONFIG_WALNUT_PPCBOOT/CONFIG_WALNUT_OB*/
 
-/* Some 4xx parts use a different timebase frequency from the internal clock.
-*/
-#define bi_tbfreq bi_intfreq
+#ifdef CONFIG_PPC405GP_INTERNAL_CLOCK
+#define BASE_BAUD		201600
+#else
+#define BASE_BAUD		691200
+#endif
 
+#define PPC4xx_MACHINE_NAME	"IBM Walnut"
+
+#endif /* !CONFIG_MULTI_405 */
 
 /* Memory map for the IBM "Walnut" 405GP evaluation board.
  * Generic 4xx plus RTC.
@@ -64,12 +81,6 @@
 #define KEYBOARD_IRQ		25
 #define AUX_IRQ			26
 
-#ifdef CONFIG_PPC405GP_INTERNAL_CLOCK
-#define BASE_BAUD		201600
-#else
-#define BASE_BAUD		691200
-#endif
-
 #define WALNUT_PS2_BASE		0xF0100000
 #define WALNUT_FPGA_BASE	0xF0300000
 
@@ -80,8 +91,6 @@
 #define kbd_read_status()	readb(kb_cs)
 #define kbd_write_output(val)	writeb(val, kb_data)
 #define kbd_write_command(val)	writeb(val, kb_cs)
-
-#define PPC4xx_MACHINE_NAME	"IBM Walnut"
 
 #endif /* !__ASSEMBLY__ */
 #endif /* __ASM_WALNUT_H__ */
